﻿//-----------------------------------------------------------------------
// <copyright file="RoleRepository.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//--------------------------------------------------------------------
namespace Deixei.Domain.Repository
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;

    /// <summary>
    /// Role Repository
    /// </summary>
    public class RoleRepository : Repository<Role>, IRoleRepository
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RoleRepository" /> class.
        /// </summary>
        /// <param name="unitOfWork">The unit of work.</param>
        public RoleRepository(IUnitOfWork unitOfWork)
            : base(unitOfWork)
        {
        }
    }

    /// <summary>
    /// Role Repository Interface
    /// </summary>
    public interface IRoleRepository : IRepository<Role>
    {
    }
}

