﻿//-----------------------------------------------------------------------
// <copyright file="ControlFactory.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//--------------------------------------------------------------------
namespace Deixei.Web
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;

    /// <summary>
    /// Control Factory
    /// </summary>
    public static class ControlFactory
    {
        /// <summary>
        /// Creates this instance.
        /// </summary>
        /// <typeparam name="TControl">The type of the control.</typeparam>
        /// <returns></returns>
        public static TControl Create<TControl>() where TControl : ControlBase, new()
        {
            return Activator.CreateInstance<TControl>();
        }
    }
}
