﻿//-----------------------------------------------------------------------
// <copyright file="IAuditable.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//---------------------------------------------------------------------
namespace Deixei.Domain
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;

    /// <summary>
    /// Auditable Interface. gives properties to audit a record in the database.
    /// </summary>
    public interface IAuditable
    {
        /// <summary>
        /// Gets or sets the created by.
        /// </summary>
        /// <value>
        /// The created by username.
        /// </value>
        string CreatedBy { get; set; }
        /// <summary>
        /// Gets or sets the created.
        /// </summary>
        /// <value>
        /// created date.
        /// </value>
        DateTime Created { get; set; }
        /// <summary>
        /// Gets or sets the updated by.
        /// </summary>
        /// <value>
        /// The updated by username.
        /// </value>
        string UpdatedBy { get; set; }
        /// <summary>
        /// Gets or sets the updated.
        /// </summary>
        /// <value>
        /// The updated date.
        /// </value>
        DateTime? Updated { get; set; }
    }
}
