﻿//-----------------------------------------------------------------------
// <copyright file="OAuthMembership.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//---------------------------------------------------------------------
namespace Deixei.Domain
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel.DataAnnotations;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;

    public class OAuthMembership
    {
        /// <summary>
        /// Gets or sets the provider.
        /// </summary>
        /// <value>
        /// The provider.
        /// </value>
        [Key, Column(Order = 1)]
        public string Provider
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the provider user id.
        /// </summary>
        /// <value>
        /// The provider user id.
        /// </value>
        [Key, Column(Order = 2)]
        public string ProviderUserId
        {
            get;
            set;
        }

        /// <summary>
        /// Gets or sets the user id.
        /// </summary>
        /// <value>
        /// The user id.
        /// </value>
        public int UserId
        {
            get;
            set;
        }
    }
}
