﻿//-----------------------------------------------------------------------
// <copyright file="CustomerRepository.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//----------------------------------------------------------------------
namespace Deixei.Domain.Repository
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;
    using Microsoft.Practices.Unity;
    using Microsoft.Practices.Unity.InterceptionExtension;

    /// <summary>
    /// CustomerRepository Interface
    /// </summary>
    public interface ICustomerRepository : IRepository<Customer>
    {
    }

    /// <summary>
    /// CustomerRepository Repository
    /// </summary>
    public class CustomerRepository : Repository<Customer>, ICustomerRepository
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="CustomerRepository" /> class.
        /// </summary>
        /// <param name="unitOfWork">The unit of work.</param>
        public CustomerRepository(IUnitOfWork unitOfWork)
            : base(unitOfWork)
        {
        }
    }
}
