﻿//-----------------------------------------------------------------------
// <copyright file="OrderTypeRepository.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//----------------------------------------------------------------------
namespace Deixei.Domain.Repository
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;
    using Microsoft.Practices.Unity;
    using Microsoft.Practices.Unity.InterceptionExtension;

    /// <summary>
    /// OrderTypeRepository Repository Interface
    /// </summary>
    public interface IOrderTypeRepository : IRepository<OrderType>
    {
    }

    /// <summary>
    /// OrderTypeRepository Repository
    /// </summary>
    public class OrderTypeRepository : Repository<OrderType>, IOrderTypeRepository
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="OrderTypeRepository" /> class.
        /// </summary>
        /// <param name="unitOfWork">The unit of work.</param>
        public OrderTypeRepository(IUnitOfWork unitOfWork)
            : base(unitOfWork)
        {
        }
    }
}
