﻿//-----------------------------------------------------------------------
// <copyright file="PersonRepository.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//----------------------------------------------------------------------
namespace Deixei.Domain.Repository
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;
    using Microsoft.Practices.Unity;
    using Microsoft.Practices.Unity.InterceptionExtension;

    /// <summary>
    /// PersonRepository Repository Interface
    /// </summary>
    public interface IPersonRepository : IRepository<Person>
    {
    }

    /// <summary>
    /// PersonRepository Repository
    /// </summary>
    public class PersonRepository : Repository<Person>, IPersonRepository
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="PersonRepository" /> class.
        /// </summary>
        /// <param name="unitOfWork">The unit of work.</param>
        public PersonRepository(IUnitOfWork unitOfWork)
            : base(unitOfWork)
        {
        }
    }
}
