﻿//-----------------------------------------------------------------------
// <copyright file="SupplierRepository.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//----------------------------------------------------------------------
namespace Deixei.Domain.Repository
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;
    using Microsoft.Practices.Unity;
    using Microsoft.Practices.Unity.InterceptionExtension;

    /// <summary>
    /// SupplierRepository Repository Interface
    /// </summary>
    public interface ISupplierRepository : IRepository<Supplier>
    {
    }

    /// <summary>
    /// SupplierRepository Repository
    /// </summary>
    public class SupplierRepository : Repository<Supplier>, ISupplierRepository
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SupplierRepository" /> class.
        /// </summary>
        /// <param name="unitOfWork">The unit of work.</param>
        public SupplierRepository(IUnitOfWork unitOfWork)
            : base(unitOfWork)
        {
        }
    }
}
