﻿//-----------------------------------------------------------------------
// <copyright file="VendorRepository.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//----------------------------------------------------------------------
namespace Deixei.Domain.Repository
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;
    using Microsoft.Practices.Unity;
    using Microsoft.Practices.Unity.InterceptionExtension;

    /// <summary>
    /// VendorRepository Repository Interface
    /// </summary>
    public interface IVendorRepository : IRepository<Vendor>
    {
    }

    /// <summary>
    /// VendorRepository Repository
    /// </summary>
    public class VendorRepository : Repository<Vendor>, IVendorRepository
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="VendorRepository" /> class.
        /// </summary>
        /// <param name="unitOfWork">The unit of work.</param>
        public VendorRepository(IUnitOfWork unitOfWork)
            : base(unitOfWork)
        {
        }
    }
}
