﻿//-----------------------------------------------------------------------
// <copyright file="ServiceLayerContext.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//---------------------------------------------------------------------
namespace Deixei.Domain.Service
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;
    using System.Threading.Tasks;
    using Deixei;
    using Deixei.Domain.Repository;
    using Microsoft.Practices.Unity;
    using Microsoft.Practices.Unity.InterceptionExtension;

    /// <summary>
    /// Service Layer Context, this is the entry point for all services. Service Hub.
    /// </summary>
    public class ServiceLayerContext
    {
        /// <summary>
        /// Gets or sets the customer service.
        /// </summary>
        /// <value>
        /// The customer service.
        /// </value>
        public ICustomerService CustomerService { get; set; }
        /// <summary>
        /// Gets or sets the navigation service.
        /// </summary>
        /// <value>
        /// The navigation service.
        /// </value>
        public INavigationService NavigationService { get; set; }

        public IAuthorizationService AuthorizationService { get; set; }
        
    }
}
