﻿//-----------------------------------------------------------------------
// <copyright file="IUnitOfWork.cs" company="deixei.com">
//     Copyright (c) deixei.com. All rights reserved.
// </copyright>
// <author>Marcio Parente</author>
//----------------------------------------------------------------------
namespace Deixei.Domain
{
    using System;
    using System.Collections.Generic;
    using System.Data.Entity;
    using System.Data.Objects;
    using System.Linq;
    using System.Text;

    /// <summary>
    /// Unit Of Work Interface
    /// </summary>
    public interface IUnitOfWork : IDisposable
    {
        /// <summary>
        /// Gets or sets the context.
        /// </summary>
        /// <value>
        /// The context.
        /// </value>
        DataContext Context { get; set; }

        /// <summary>
        /// Saves this instance.
        /// </summary>
        void Save(); 
    }
}
